SystemOrganization addCategory: #Rizel!
SystemOrganization addCategory: #'Rizel-Tests'!

TestCase subclass: #RizelBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tests'!

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:12'!
testCreation
	"Creational test"
	|browser|
	browser := RizelBrowser new.
	browser openOn: (RizelEnviroment new).
	
! !

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:13'!
testCreation2
	"Creational test"
	|browser|
	browser := RizelBrowser new.
	browser openOn: (RizelRunnerTest env).
	
! !

TestCase subclass: #RizelRunnerTest
	instanceVariableNames: ''
	classVariableNames: 'env'
	poolDictionaries: ''
	category: 'Rizel-Tests'!

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:07'!
env
	^ env.! !

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:06'!
env:  aEnv
	env:= aEnv.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:31'!
historyDiagram
	| diag canvas|
	diag := ESDiagramRenderer new.
	(diag historyDiagram)
		dataset: #history;
		width: 500;
		height: 400;
		attribute: #yValue;
		regularAxis;
		horizontalLegend;
		color: #color;
		useColors: ESAbstractDiagram lightColors;
		models: self projects.
	diag interaction 
		strongHighlightWhenOver.
	canvas := diag open.
	canvas delete.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:29'!
projects
	
	| dummies1 dummies2 dummies3 historyObject LOC1 LOC2 LOC3 combination LOC4 LOC5 LOC6 dummies4 dummies5 dummies6 |
	dummies1 := ESDummyFactory new.
	dummies2 := ESDummyFactory new.
	dummies3 := ESDummyFactory new.
	dummies4 := ESDummyFactory new.
	dummies5 := ESDummyFactory new.
	dummies6 := ESDummyFactory new.
	historyObject := ESDummyFactory new.
	LOC1 := #(1 2 3 4 5 6 7 8 10 10 10 10 10 10 10 10 7 8 10 10 10 12 13 13 14 19 10).
	LOC2 := #(13 12 11 10 10 11 12 12 12 14 9 10 11 12 11 16 15 14 13 16 15 14 10 10 15 20 30).
	LOC3 := #(16 15 14 13 12 15 15 16 18 19 18 10 11 11 12 13 14 12 10 5 3 2 1 1 0 0 0).
	LOC4 := #(1 1 1 2 3 4 4 4 4 3 4 2 3 4 3 5 8 15 19 20 14 15 18 12 14 13 14).
	LOC5 := #(13 12 11 10 10 11 16 15 14 12 10 10 12 13 14 14 19 21 22 23 24 25 35 40 45 50 60).
	LOC6 := #(1 2 3 4 2 3 3 2 2 3 2 1 2 3 4 2 1 5 6 8 10 12 13 15 12 12 12).
	dummies1 yValues: LOC1.
	dummies2 yValues: LOC2.
	dummies3 yValues: LOC3.
	dummies4 yValues: LOC4.
	dummies5 yValues: LOC5.
	dummies6 yValues: LOC6.
	combination := OrderedCollection new.
	combination add: dummies1 buildDummies.
	combination add: dummies2 buildDummies.
	combination add: dummies3 buildDummies.
	combination add: dummies4 buildDummies.
	combination add: dummies5 buildDummies.
	combination add: dummies6 buildDummies.
	historyObject colors: #('Alpha' 'Beta' 'Delta' 'Epsilon' 'Gamma' 'Zeta').
	historyObject histories: combination.
	^historyObject buildDummies! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 18:06'!
testBasic
	|rep versions v80 runner|
	rep := MCHttpRepository location:'http://www.squeaksource.com/EyeSee'  user: '' password: ''.
	versions := ( (rep versionNamesBetween: 80 and: 85 every: 1) select:[:each | '*Core*' match: each]).
	v80 := versions first.
	runner := RizelVersionRunner repository: rep version: v80.
	runner profile: [ ESExamples new historyDiagram3. ].! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:32'!
testEnviroment
	| t1 t2 t3 t4 t5 |
	t2 := MCHttpRepository
				location: 'http://www.squeaksource.com/EyeSee'
				user: ''
				password: ''.
	t3 := (t2
				versionNamesBetween: 80
				and: 85
				every: 1)
				select: [:t6 | '*Core*' match: t6].
	t1 := RizelEnviroment new.
	RizelRunnerTest env: t1.
	t3
		do: [:t6 | 
			| t7 t8 t9 |
			t7 := RizelVersionRunner repository: t2 version: t6.
			t8 := t7
						profile: [
							100 timesRepeat: [ 
								self historyDiagram.
								].
"							] on: Error do: [
							Transcript show:'ERROR';cr.]"].
			t9 := RizelVersion new.
			t9 tally: t8;
				 versionNumber: t6.
			t1 addVersion: t9 ].
	^ t1! !

Object subclass: #RizelBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:05'!
browser
	""
	|browser|
	browser := GLMTabulator new.
	
	browser column: #methods span: 4;
	column: #eyesee   span: 10;
	column: [ :c |
		c row: #methodName span:1;
		   row: #detail span: 10.
		]    span: 2.
	
	browser transmit
		to: #methods;
		from: #outer port: #entity;
		andShow:[ :a | self methodsOn: a].
		
	browser transmit
		to: #eyesee;
		from: #outer port: #entity;
		from: #methods;
		andShow:[ :a | self eyeseeOn: a ].
	
	^ browser.
	! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:15'!
eyeseeOn: presentation
	^ presentation eyesee
			when: [ :env :method | env notNil and: [ method notNil ]];
			diagram: [ :renderer :env :method|
					| diag |
					diag := (renderer lineDiagram).
					diag
						y: [: rv |  self timeOn: rv in: method];
						identifier: #versionNumber;
						yAxisLabel: 'Time';
						rotatedLabels: true;
						defaultColor: Color blue;
						models: (env versions);
						regularAxis. 
					diag].! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:42'!
methodsOn: a
	^ a list
			useExplicitNotNil;
			when: [ :env | env notNil];
			display: [ :env | env methods];
			format: [ :method | (method methodClass name),'>>',(method selector) ].! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:11'!
openOn: aRizelEnviroment
	""
	self browser openOn: aRizelEnviroment.! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:16'!
timeOn: aVersion in: aMethod
	|time mt|
	time := 0.
	mt := aVersion tallyOf: aMethod.
	mt ifNotNil: [
		Transcript show: (mt time asString );cr.
		 time := mt time
		].
	^ time.! !

Object subclass: #RizelEnviroment
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:46'!
addVersion: aMessageTail
	versions add: aMessageTail.! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: ''!
estEnviroment
	| t1 t2 t3 t4 t5 |
	t2 := MCHttpRepository
				location: 'http://www.squeaksource.com/EyeSee'
				user: ''
				password: ''.
	t3 := (t2
				versionNamesBetween: 80
				and: 85
				every: 1)
				select: [:t6 | '*Core*' match: t6].
	t1 := RizelEnviroment new.
	t3
		do: [:t6 | 
			| t7 t8 t9 |
			t7 := RizelVersionRunner repository: t2 version: t6.
			t8 := t7
						profile: [[ESExamples new historyDiagram3]
								on: Error
								do: []].
			t9 := RizelVersion new.
			t9 tally: t8;
				 versionNumber: t6.
			"t1 addVersion: t9"
			].
	self assert: t3 size = t1 versions size.
	^ t1! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:09'!
initialize
	super initialize.
	versions := OrderedCollection new.
! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:38'!
methods
	^  versions last methods.! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:45'!
versions
	^ versions.! !

!RizelEnviroment methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versions: anObject
	versions := anObject! !

Object subclass: #RizelRunner
	instanceVariableNames: 'tally pollingEvery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

RizelRunner subclass: #RizelBasicRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelBasicRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:39'!
profile: aBlock
	| stream list result |
	
	tally := MessageTally new.
	tally
		reportOtherProcesses: false;
		maxClassNameSize: 1000;
		maxClassPlusSelectorSize: 1000;
		maxTabs: 100.
	
	tally spyEvery: pollingEvery on: aBlock.
	^ tally.! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 16:29'!
initialize 
	super initialize.
	pollingEvery := MessageTally defaultPollPeriod.
	! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 16:26'!
pollingEvery: aPollingEvery
	pollingEvery:= aPollingEvery! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:38'!
profile: aBlock
	! !

RizelRunner subclass: #RizelVersionRunner
	instanceVariableNames: 'version repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelVersionRunner class methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 18:43'!
repository: t1 version: t2
	| t3 |
	t3 := RizelVersionRunner new
		repository: t1;
		version: t2.
	^ t3! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 18:56'!
profile: aBlock
	| stream list result |
	
	Gofer new repository: repository;
						 version: version;
						 load.
	tally := MessageTally new.
	tally
		reportOtherProcesses: false;
		maxClassNameSize: 1000;
		maxClassPlusSelectorSize: 1000;
		maxTabs: 100.
	
	tally spyEvery: pollingEvery on: aBlock.
	^ tally.! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:36'!
repository
	repository! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:36'!
repository: aRepository
	repository := aRepository.! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:37'!
version
	version.! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:36'!
version: aVersion
	version:= aVersion.! !

Object subclass: #RizelVersion
	instanceVariableNames: 'tally versionNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:37'!
asOrderedCollection
	^ (self select:[ : m | true]) collect: [ :mt | mt method].! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:35'!
methods
	^ (
	
	((self select:[ : m | true])  asSortedCollection:[ :A :B | B time > A time] )
	
	collect: [ :mt | mt method]) asSet.! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:34'!
select: aBlock
	| stack result |
	stack := Stack new.
	result := OrderedCollection new.
	stack push: tally.
	[stack isEmpty] whileFalse: [
		|m|
		m := stack pop.
		( aBlock value: m ) ifTrue: [ result add: m. ].
		m receivers do: [ : m1| stack push: m1. ].  ].
	^ result.! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
tally
	^ tally! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
tally: anObject
	tally := anObject! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:01'!
tallyOf: method
	|result|
	result := (self select:[ :m | m method = method]).
	result ifEmpty: [ ^ nil. ].
	^ result anyOne.
	! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versionNumber
	^ versionNumber! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versionNumber: anObject
	versionNumber := anObject! !
